/**
 * Pure Java Applet.
 * This program demonstrates how to realize an Applet.
 *
 * This file was automatically generated by
 * Omnicore CodeGuide.


	Written by D. Kovachev
 */

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.util.StringTokenizer;
import POP3Session;

/**
 * Applet class.
 */
public class POP3MailReader extends Applet implements ActionListener, MouseListener
{
	private Label labelMessages 	= new Label("Message shown : ");
	private Label labelFrom			= new Label("From :");
	private Label labelTo			= new Label("To   :");
	private Label labelSubj			= new Label("Subj :");
	
	private TextField textPOP3 		= new TextField(15);
	private TextField textUserName 	= new TextField(15);
	private TextField textPassword 	= new TextField(15);

	private TextArea textStatus 	= new TextArea("POP3 Applet started.", 2, 45, TextArea.SCROLLBARS_VERTICAL_ONLY);
	private TextArea areaMessageText = new TextArea(20, 40);
	
	private List listOfMessages 	= new List(30, false);
	
	private Button buttonConnect 	= new Button("Connect");
	
	private MenuItem menuItem1 		= new MenuItem();
	private MenuItem menuItem2 		= new MenuItem();
	private PopupMenu popupMenu 	= new PopupMenu();
	
	private boolean isConnected;
	
	private Color disabledColor;
	private Color backgroundColor;
	
	private POP3Session pop;
	
	public void init()
	{
		try
		{
			addComponents();
		}
		catch (Exception e)
		{
			System.out.println("Exception caught : Line 54");
			e.printStackTrace();
		}
		isConnected = false;
	}
	
	public void destroy()
	{
		if (isConnected) {
			doDisconnect();
		}
	}
	
	public void actionPerformed (ActionEvent ae)
	{
		if (ae.getSource().equals(buttonConnect))
		{
			if (!isConnected){
				doConnect();
			}
			else{
				doDisconnect();
			}
		}
		else
		if (ae.getSource().equals(menuItem1)) {
			doReadMsg();
		}
		else
		if (ae.getSource().equals(menuItem2)) {
			doDeleteMsg();
		}
	}
	
	public void mouseClicked(MouseEvent e)
	{
	}
	public void mouseReleased(MouseEvent e)
	{
	}
	public void mouseEntered(MouseEvent e)
	{
	}
	public void mouseExited(MouseEvent e)
	{
	}
	public void mousePressed(MouseEvent e) {
		// register when user pressed right mouse button
		// - e.getModifiers()==e.BUTTON3_MASK -
		// and when is "mouse down" - e.MOUSE_PRESSED==501.
		if ((e.getModifiers()==e.BUTTON3_MASK)&&(e.MOUSE_PRESSED==501))
			if (-1 != listOfMessages.getSelectedIndex())
			{
				popupMenu.show (e.getComponent(), e.getX(), e.getY());
			}
	}
	private String getFirstString(String str)
	{
		StringTokenizer st = new StringTokenizer(str);
		
		String firstString = st.nextToken();
		String secondString = st.nextToken();
		
		return firstString;
	}
	private String getSecondString(String str)
	{
		StringTokenizer st = new StringTokenizer(str);
		
		String firstString = st.nextToken();
		String secondString = st.nextToken();
		
		return secondString;
	}
	
	private void doConnect()
	{
		textPOP3.setBackground(disabledColor);
		textPOP3.setEditable(false);
		textUserName.setBackground(disabledColor);
		textUserName.setEditable(false);
		textPassword.setBackground(disabledColor);
		textPassword.setEditable(false);
		
		buttonConnect.setLabel("Disconnect");
		buttonConnect.setEnabled(false);
		
		String host = textPOP3.getText();
		String user = textUserName.getText();
		String pass = textPassword.getText();
		
		textStatus.append("\nConnecting to " + host + " ...");
		pop = new POP3Session(host, user, pass);
		try
		{
			pop.connectAndAuthenticate();
		}
		catch (java.io.IOException e)
		{
			textStatus.append("\nERROR : Connection to server failed.");
			textStatus.append("\nERROR Text : " + e.getMessage());
			System.out.println("Exception caught : Line 155");
			e.printStackTrace();
			doDisconnect();
			return;
		}
		
		buttonConnect.setEnabled(true);
		
		textStatus.append("\nSuccessfully connected to " + host);
		isConnected = true;
		areaMessageText.setText("");
		
		textStatus.append("\nRetrieving new messages... ");
		String[] msgNames;
		try
		{
			msgNames = pop.getHeaders();
		}
		catch (java.io.IOException e)
		{
			textStatus.append("\nERROR : Can't retrieve message info.");
			textStatus.append("\nERROR Text : " + e.getMessage());
			System.out.println("Exception caught : Line 177");
			e.printStackTrace();
			return;
		}
		
		textStatus.append("\n" + msgNames.length + " new messages found on server.");

		for (int i = 0; i < msgNames.length; i++) {
			listOfMessages.add(msgNames[i]);
		}
				
		labelMessages.setText("Message shown : ");
		
		listOfMessages.setEnabled(true);
	}
	
	private void doDisconnect()
	{
		textPOP3.setBackground(Color.white);
		textPOP3.setEditable(true);
		textUserName.setBackground(Color.white);
		textUserName.setEditable(true);
		textPassword.setBackground(Color.white);
		textPassword.setEditable(true);
		
		labelFrom.setText("From:");
		labelTo.setText("To  :");
		labelSubj.setText("Subj:");
		
		buttonConnect.setEnabled(false);
		buttonConnect.setLabel("Connect");
		
		listOfMessages.removeAll();
		
		areaMessageText.setText("");

		textStatus.append("\nDisconnected.");
		labelMessages.setText("Message shown : ");
				
		try
		{
			if (isConnected)
			{
				pop.quit();
				pop.close();
			}
		}
		catch (java.io.IOException e)
		{
			System.out.println("Exception caught : Line 222");
		}

		buttonConnect.setEnabled(true);
		isConnected = false;
	}
	
	private void doReadMsg()
	{
		String msgID = getFirstString(listOfMessages.getSelectedItem());
		
		textStatus.append("\nRetrieving message " + msgID + " from server...");
		
		String msgText = "";
		
		try
		{
			msgText = pop.getMessage(msgID);
		}
		catch (java.io.IOException e)
		{
			textStatus.append("\nERROR : Can't retrieve message from server.");
			textStatus.append("\nERROR Text : " + e.getMessage());
			System.out.println("Exception caught : Line 245");
			e.printStackTrace();
			return;
		}
		
		textStatus.append("\nMessage " + msgID + " successfully retrieved.");
		
		String strTmp;
		int pos;
		
		strTmp = "";
		pos = msgText.indexOf("From:");
		while (msgText.charAt(pos) != '\n')
		{
			strTmp += msgText.charAt(pos);
			pos++;
		}
		labelFrom.setText(strTmp);
		
		strTmp = "";
		pos = msgText.indexOf("To:");
		while (msgText.charAt(pos) != '\n')
		{
			strTmp += msgText.charAt(pos);
			pos++;
		}
		labelTo.setText(strTmp);
		
		strTmp = "";
		pos = msgText.indexOf("Subject:");
		while (msgText.charAt(pos) != '\n')
		{
			strTmp += msgText.charAt(pos);
			pos++;
		}
		labelSubj.setText(strTmp);
		
		pos = msgText.indexOf("\n\n");
		msgText = msgText.substring(pos+2);
		
		areaMessageText.setText(msgText);
		
		String msgSize = getSecondString(listOfMessages.getSelectedItem());
		labelMessages.setText("Message shown : " + msgID + " (" + msgSize + " bytes)");
	}
	
	private void doDeleteMsg()
	{
		String msgID = getFirstString(listOfMessages.getSelectedItem());
		int msgListIndex = listOfMessages.getSelectedIndex();
		
		textStatus.append("\nDeleting message " + msgID + " ...");
		
		try
		{
			pop.deleteMessage(msgID);
		}
		catch (java.io.IOException e)
		{
			textStatus.append("\nERROR : Can't delete message from server.");
			textStatus.append("\nERROR Text : " + e.getMessage());
			System.out.println("Exception caught : Line 273");
			e.printStackTrace();
			return;
		}
		
		textStatus.append("\nMessage " + msgID + " successfully deleted.");
		listOfMessages.delItem(msgListIndex);
	}
	
	private void addComponents() throws Exception
	{
		// Read the do-resize params from the HTML
		boolean bResizeX = false;
		boolean bResizeY = false;
		
		if (this.getParameter("resizeX").toLowerCase().equals("true"))
			bResizeX = true;
		if (this.getParameter("resizeY").toLowerCase().equals("true"))
			bResizeY = true;
		
		// Create a layout and constraints objects.
		GridBagLayout layout 	= new GridBagLayout();
		GridBagConstraints GBC 	= new GridBagConstraints();
		
		backgroundColor	= getColorFromString(this.getParameter("backgroundColor"), Color.white);
		disabledColor 	= getColorFromString(this.getParameter("disabledColor"), Color.lightGray);
		
		this.setLayout(layout);
		this.setBackground(backgroundColor);
				
		// Set common properties of all labels, text fielsds nad buttons
		GBC.gridwidth 	= 1;
		GBC.gridheight 	= 1;
		GBC.fill 		= GridBagConstraints.HORIZONTAL;
		GBC.weightx 	= bResizeX ? 1.0 : 0.0;
		GBC.weighty 	= 0.0;
		
				
		// Create the "POP3 Server :" label and add it to the layout
		GBC.gridx 		= 0;
		GBC.gridy 		= 0;
		Label labelPOP3 = new Label("POP3 Server :");
		layout.setConstraints(labelPOP3, GBC);
		this.add(labelPOP3);
		
		// Set the "POP3 Server :" text field and add it to the layout
		GBC.gridx 		= 1;
		GBC.gridy 		= 0;
		layout.setConstraints(textPOP3, GBC);
		this.add(textPOP3);
		
		// Create the "Login :" label and add it to the layout
		GBC.gridx 		= 2;
		GBC.gridy 		= 0;
		Label labelUserName = new Label("   Login :");
		layout.setConstraints(labelUserName, GBC);
		this.add(labelUserName);
		
		// Set the "Login :" text field and add it to the layout
		GBC.gridx 		= 3;
		GBC.gridy 		= 0;
		layout.setConstraints(textUserName, GBC);
		this.add(textUserName);
		
		// Create the "Password :" label and add it to the layout
		GBC.gridx 		= 4;
		GBC.gridy 		= 0;
		Label labelPassword = new Label("   Password :");
		layout.setConstraints(labelPassword, GBC);
		this.add(labelPassword);
		
		// Set the "Password :" text field and add it to the layout
		GBC.gridx 		= 5;
		GBC.gridy 		= 0;
		textPassword.setEchoChar('*');
		layout.setConstraints(textPassword, GBC);
		this.add(textPassword);
		
		// Set the "(Dis)Connect" button and add it to the layout
		GBC.gridx 		= 5;
		GBC.gridy 		= 1;
		layout.setConstraints(buttonConnect, GBC);
		buttonConnect.addActionListener(this);
		this.add(buttonConnect);
		
		// Set the "Message :" label and add it to the layout
		GBC.gridx 		= 0;
		GBC.gridy 		= 1;
		GBC.gridwidth 	= 5;
		layout.setConstraints(labelMessages, GBC);
		this.add(labelMessages);
		
		GBC.gridy 		= 2;
		GBC.gridheight 	= 1;
		GBC.gridwidth 	= 2;
		

		GBC.gridx 		= 0;
		layout.setConstraints(labelFrom, GBC);
		labelFrom.setEnabled(true);
		this.add(labelFrom);
		
		GBC.gridx 		= 2;
		layout.setConstraints(labelTo, GBC);
		this.add(labelTo);

		GBC.gridx 		= 4;
		layout.setConstraints(labelSubj, GBC);
		this.add(labelSubj);

		
		// Init pop-up menu items
		menuItem1.setLabel("Read message");
		menuItem1.addActionListener (this);
		menuItem2.setLabel("Delete message");
		menuItem2.addActionListener (this);
		
		// Init the pop-up menu
		popupMenu.add(menuItem1);
		popupMenu.add(menuItem2);
		popupMenu.addActionListener(this);
		
		
		// Set common properties of the text area and the message list
		GBC.gridy 		= 3;
		GBC.gridheight 	= 15;
		GBC.weighty 	= bResizeY ? 1.0 : 0.0;
		GBC.fill 		= GridBagConstraints.BOTH;
		

		// Set the text area and add it to the layout
		GBC.gridx 		= 0;
		GBC.gridwidth 	= 5;
		layout.setConstraints(areaMessageText, GBC);
		areaMessageText.setEditable(false);
		areaMessageText.setBackground(getColorFromString(this.getParameter("msgAreaColor"), Color.magenta));
		areaMessageText.setText(this.getParameter("initMsgAreaText"));
		this.add(areaMessageText);
		
		// Set the list's position and size
		GBC.gridx 		= 5;
		GBC.gridwidth 	= 1;
		layout.setConstraints(listOfMessages, GBC);
		listOfMessages.addActionListener(this);
		listOfMessages.addMouseListener(this);
		listOfMessages.add(popupMenu);
		listOfMessages.setEnabled(false);
		listOfMessages.setBackground(backgroundColor);
		this.add(listOfMessages);
		
		// Set the status bar and add it to the layout
		GBC.gridx 		= 0;
		GBC.gridy 		= 18;
		GBC.gridwidth 	= 6;
		GBC.weighty 	= bResizeY ? 0.10 : 0.0;
		layout.setConstraints(textStatus, GBC);
		textStatus.setEditable(false);
		textStatus.setForeground(Color.black);
		textStatus.setBackground(backgroundColor);
		this.add(textStatus);
		
	}
	
	private Color getColorFromString(String s, Color defaultColor)
	{
		Color c;
		try
		{
			c = new Color(Integer.parseInt(s, 16));
		}
		catch (Exception e)
		{
			c = defaultColor;
		}
		return c;
	}
}



