// Written by D. Kovachev
import java.io.*;
import java.net.*;

class PingThread extends Thread
{
	protected Socket pop3Socket;
    protected BufferedReader in;
    protected PrintWriter out;
	
	public PingThread(Socket s)
	{
		pop3Socket = s;
		
		try
		{
			in = new BufferedReader(new InputStreamReader(pop3Socket.getInputStream()));
			out = new PrintWriter(new OutputStreamWriter(pop3Socket.getOutputStream()));
		}
		catch (IOException e)
		{
		}
	}

	public void run()
	{
		System.out.println("The ping thread says 'Hello'...");
		try
		{
			while (true)
			{
				sleep20sec();
				synchronized (pop3Socket)
				{
					doCommand("STAT");
					System.out.println("STAT command send. Go back to sleep...");
				}
			}
		}
		catch (Exception e)
		{
			// The socket is closed. That's OK. Stop the thread.
		}
		System.out.println("The ping thread says 'Bye-Bye'.\n");
	}

	void sleep20sec()
	{
		try {
			this.sleep(20000);
		} catch (InterruptedException x)
		{
		}
	}
    protected String doCommand(String command)
    throws IOException
    {
        out.println(command);
        out.flush();
        String response = in.readLine();
        checkForError(response);
        return response;
    }
	
    protected void checkForError(String response)
    throws IOException
    {
		try
		{
			if (response.charAt(0) != '+')
				throw new IOException(response);
		}
		catch (Exception e)
		{
			throw new IOException("No response");
		}
    }
}

