import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author Milena Iordanova
 * @version 1.0
 */

public class PicturesAppletClass extends Applet {
  List list1 = new List();
  Panel panel1 = new Panel();
  Label label2 = new Label();
  BorderLayout borderLayout1 = new BorderLayout();
  BorderLayout borderLayout2 = new BorderLayout();
  Panel panel2 = new Panel();
  Label label1 = new Label();
  Panel panel3 = new Panel();
  FlowLayout flowLayout1 = new FlowLayout();
  Button button1 = new Button();
  Button button2 = new Button();
  BorderLayout borderLayout3 = new BorderLayout();

  private Image currentPicture;
  private int newh, neww;
  private Rectangle rect;

  public PicturesAppletClass() {
  }

  public void init() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  public void paint(Graphics g) {
    paintPicture(g);
  }

  private void paintPicture(Graphics g)
  {
    if(currentPicture != null)
    {
      g.drawImage(currentPicture,
                  rect.x + (rect.width - neww) / 2,
                  rect.y + (rect.height - newh) / 2,
                  this);
    }

    int wx = rect.x + rect.width - 1;
    int wy = rect.y + rect.height - 1;

    g.drawLine(rect.x, rect.y, wx, rect.y);
    g.drawLine(wx, rect.y, wx, wy);
    g.drawLine(wx, wy, rect.x, wy);
    g.drawLine(rect.x, wy, rect.x, rect.y);
  }

  private void jbInit() throws Exception {
    this.setLayout(borderLayout2);
    panel1.setBackground(Color.darkGray);
    panel1.setLayout(borderLayout1);
    label2.setAlignment(1);
    label2.setForeground(Color.white);
    label2.setText("No picture loaded");
    panel2.setLayout(borderLayout3);
    panel3.setLayout(flowLayout1);
    button1.setLabel("Load list");
    button1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        button1_actionPerformed(e);
      }
    });
    button2.setLabel("Show picture");
    button2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        button2_actionPerformed(e);
      }
    });
    list1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        list1_actionPerformed(e);
      }
    });
    this.add(list1, BorderLayout.WEST);
    this.add(panel2, BorderLayout.SOUTH);
    panel2.add(label1, BorderLayout.NORTH);
    panel2.add(panel3, BorderLayout.CENTER);
    panel3.add(button1, null);
    panel3.add(button2, null);
    this.add(panel1, BorderLayout.CENTER);
    panel1.add(label2, BorderLayout.CENTER);
  }

  private String[] GetPictureList() throws java.io.IOException {
    Socket s = null;
    String[] pics;

    try {
      String hostName = this.getCodeBase().getHost();
      s = new Socket(hostName , 3002);
      BufferedReader br = new BufferedReader(new InputStreamReader(s.getInputStream()));
      BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(s.getOutputStream()));

      bw.write("LIST");
      bw.newLine();
      bw.flush();

      int numPics = Integer.parseInt(br.readLine());

      pics = new String[numPics];

      for(int i = 0; i < numPics; i++)
      {
        String str = br.readLine();
        pics[i] = str;
      }
    }
    finally {
      if(s != null)
        s.close();
    }

    return pics;
  }

  private byte[] GetPicture(String pName) throws java.io.IOException {
    Socket s = null;
    byte[] pic = null;
    int pictureSize;

    try {
      String hostName = this.getCodeBase().getHost();
      s = new Socket(hostName , 3002);
      InputStream is = s.getInputStream();
      BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(s.getOutputStream()));

      bw.write("GET " + pName);
      bw.newLine();
      bw.flush();

      byte[] b = new byte[10];
      byte[] b1 = new byte[1];
      int i;

      for(i = 0; i < 10; i++) {
        is.read(b1);
        if(b1[0] == 0x0a)
          break;
        b[i] = b1[0];
      }

      if(b[i-1] == 0x0d)
        i--;

      pictureSize = Integer.parseInt(new String(b, 0, i));

      pic = new byte[pictureSize];
      for(i = 0; i < pictureSize; i += is.read(pic, i, pictureSize - i));
    }
    finally {
      if(s != null)
        s.close();
    }

    return pic;

  }

  void button1_actionPerformed(ActionEvent e) {
    label1.setText("");
    list1.removeAll();

    String[] pictures;
    try {
      pictures = GetPictureList();

      for(int i = 0; i < pictures.length; i++) {
        list1.add(pictures[i]);
      }
    }
    catch(java.io.IOException ie) {
      label1.setText(ie.getMessage());
    }
  }

  void button2_actionPerformed(ActionEvent e) {
    panel1.setVisible(true);
    label1.setText("");
    label2.setVisible(true);
    label2.setText("No picture loaded");
    currentPicture = null;

    try {
      String picName = list1.getSelectedItem();
      if(picName == null)
        return;

      label2.setText("Loading picture...");

      byte[] pic = GetPicture(picName);

      panel1.setVisible(false);
      label2.setVisible(false);

      Image cPic = Toolkit.getDefaultToolkit().createImage(pic);
      int h, w;
      do {
        h = cPic.getHeight(this);
        w = cPic.getWidth(this);
      }
      while(h == -1 || w == -1);

      rect = panel1.getBounds();

      double d1 = (double)w / rect.width;
      double d2 = (double)h / rect.height;
      double d = (d1 < d2 ? d2 : d1);

      if(d < 1.0) {
        newh = h;
        neww = w;
      }
      else {
        newh = (int)(h / d);
        neww = (int)(w / d);
      }

      currentPicture = cPic.getScaledInstance(neww, newh, Image.SCALE_DEFAULT);
      this.invalidate();
    }
    catch(Exception ie) {
      currentPicture = null;
      label1.setText(ie.getMessage());
      panel1.setVisible(true);
      label2.setVisible(true);
      label2.setText("No picture loaded");
    }
  }

  void list1_actionPerformed(ActionEvent e) {
    button2_actionPerformed(e);
  }

}