package nick.inetjava.pop3applet;

/**
 * Keeps an existing POP3 connection alive by pushing a 'stat' command
 * into the command queue every 20 seconds.
 *
 * @author Nick Nickolov, nick_nickolov@abv.bg
 * @version Jun 9, 2002 9:07:35 AM
 */
final class ConnectionPreservingThread extends Thread {
  private POP3Thread pop3Thread;
  private Queue queue;

  public ConnectionPreservingThread(POP3Thread pop3Thread, Queue queue) {
    this.pop3Thread = pop3Thread;
    this.queue = queue;
  }

  public void run() {
    while (true) {
      try {
        super.sleep(20000);
      } catch (InterruptedException ie) {
        // ignore
      }
      queue.push(new POP3Command(POP3Command.C_KEEP_CONNECTION, null));
    }
  }
}
