package nick.inetjava.pop3applet;

/**
 * Represents a POP3 command or a connection request.
 * The arguments array is command-dependent, e.g. a 'show message' command
 * would require a message index, a connection request ('check mail')
 * has needs a host-port pair.
 *
 * @author Nick Nickolov, nick_nickolov@abv.bg
 * @version Jun 1, 2002 4:52:17 PM
 */
final class POP3Command {
  static final int C_CHECK_MAIL       = 1;
  static final int C_DISCONNECT       = 2;
  static final int C_DELETE_MESSAGE   = 3;
  static final int C_SHOW_MESSAGE     = 4;
  static final int C_KEEP_CONNECTION  = 5;
  private int command;
  private Object[] arguments;

  POP3Command(int command, Object[] arguments) {
    this.command = command;
    this.arguments = arguments;
  }

  int getCommand() {
    return command;
  }

  Object[] getArguments() {
    return arguments;
  }
}
