package nick.inetjava.server;

import java.io.*;

/**
 * @author
 * @version 1.0
 */

final class VirtualFile {
  private String[] path;
  private File file;
  private String[] children;

  protected VirtualFile(String[] path, File file, String[] children) {
    this.path = path;
    this.file = file;
    this.children = children;
  }

  /**
   * Might be a physical or a virtual directory
   */
  protected boolean isDirectory() {
    return ((file == null) || (file.isDirectory()));
  }

  protected String[] list() {
    return children;
  }

  protected File getFile() {
    return file;
  }

  protected String[] getPath() {
    return path;
  }

  public String toString() {
    if (path.length == 0) {
      return "/";
    } else {
      return '/' + VirtualFileSystem.toString(path, 0) + '/';
    }
  }
}
